package cz.cvut.ok.kapo.paa.batoh;

import java.util.StringTokenizer;
import java.util.Vector;

import cz.cvut.ok.kapo.paa.batoh.utils.ConfigurationException;

/**
 * Obsahuje konfiguraci problemu. Ma vektor jednotlivych veci, ktere
 * se pridavaji do batohu.
 * @author karel
 *
 */
public class Configuration {
	private int id;
	private int size;
	private Vector<Item> items;
	
	public Configuration() {
		super();
		this.id=0;
		this.size=0;
		this.items=new Vector<Item>();
	}
	
//========================= init metody ==========================
	/**
	 * 1.token: ID
	 * 2.token: pocet polozek
	 * 3.token: velikost batohu
	 * 4.-n.token: vaha,cena
	 */
	public void init(StringTokenizer st) throws ConfigurationException{
		try {
			String token = st.nextToken();//prvni ID
			id = Integer.valueOf(token).intValue();
			token = st.nextToken();// druhy pocet polozek
			int n = Integer.valueOf(token).intValue();
			token = st.nextToken(); // treti velikost batohu
			size = Integer.valueOf(token).intValue();
			int tmp;
			for (int i=0; i<n; i++){
				Item item = new Item();
				token=st.nextToken();
				tmp = Integer.valueOf(token).intValue();
				item.setWeight(tmp);
				token=st.nextToken();
				tmp = Integer.valueOf(token).intValue();
				item.setCost(tmp);
				items.add(item);
			}
		}
		catch (Exception ex){
			throw new ConfigurationException("Chyba pri inicializaci konfigurace!", ex);
		}
		
	}

	/**
	 * @return Returns the id.
	 */
	public int getId() {
		return id;
	}

	/**
	 * @return Returns the size.
	 */
	public int getSize() {
		return size;
	}

	/**
	 * @return Returns the items.
	 */
	public Vector<Item> getItems() {
		return items;
	}

	/**
	 * @return Returns the number of items.
	 */
	public int getItemsCount() {
		return items.size();
	}
}
