package cz.cvut.ok.kapo.paa.batoh.engines.bf;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Stack;

import cz.cvut.ok.kapo.paa.batoh.Configuration;
import cz.cvut.ok.kapo.paa.batoh.Item;
import cz.cvut.ok.kapo.paa.batoh.engines.Engine;

/**
 * Trida pro vypocet obsazeni batohu metodou hrube sily.
 * @author karel
 */
public class BrutalForceEngine extends Engine{
	protected Item [] items;	//serazene pole veci z batohu
	
	/**
	 * Inicializuje objekt, setridi pole.
	 * @param conf konfigurace predmetu a batohu.
	 */
	public BrutalForceEngine(Configuration conf) {
		super(conf);
		items = conf.getItems().toArray(new Item[0]);
	}

	@Override protected void run(){
		Arrays.sort(items);	//setridime vzestupne

		ArrayList<Item> best=new ArrayList<Item>();
		int bestCost=getCost(best);	//vynulujeme
		int idx=0;
		Stack<Integer> st = new Stack<Integer>();
		Item itm = items[idx];
		list.add(itm);	
		st.push(new Integer(idx));//vlozime inicialni prvek
		while (!list.isEmpty() || itm.compareTo(items[items.length-1])!=0){
			if (getWeight(list)>conf.getSize()){
				list.remove(list.size()-1);
				idx = st.pop().intValue();
			}else {
				if (bestCost<getCost(list)){//pokud je aktualni cena lepsi
					bestCost=getCost(list);
					best=new ArrayList<Item>(list);
				}
				idx++; //posuneme se na dalsi prvek
				if (idx >= items.length){	//pokud jsme vycerpali vsechny prvky
					if (st.isEmpty())//znamena, ze jsme dopocitali
						break;
					idx=st.pop().intValue();
					list.remove(list.size()-1);
				}else{//vlozime do batohu dalsi vec
					st.push(new Integer(idx));
					list.add(items[idx]);
				}
			}
		}
		
		for (int i = 0; i<best.size(); i++){	//naplnime reseni
			sol.addItem(best.get(i));
		}
	}
}
