package cz.cvut.ok.kapo.paa.batoh.engines.sh;

import java.util.Arrays;

import cz.cvut.ok.kapo.paa.batoh.Configuration;
import cz.cvut.ok.kapo.paa.batoh.Item;
import cz.cvut.ok.kapo.paa.batoh.engines.Engine;

/**
 * Trida pro vypocet obsazeni batohu metodou hrube sily.
 * 
 * @author karel
 */
public class SimpleHeuristicEngine extends Engine{

	protected Item[] items; // serazene pole veci z batohu

	/**
	 * Inicializuje objekt, setridi pole.
	 * 
	 * @param conf
	 *            konfigurace predmetu a batohu.
	 */
	public SimpleHeuristicEngine(Configuration conf) {
		super(conf);
		items = new SimpleHeuristicItem[conf.getItemsCount()];
		int i=0;
		for (Item item: conf.getItems()){
			SimpleHeuristicItem tmp = new SimpleHeuristicItem(item);
			items[i++]=tmp;
		}
		Arrays.sort(items); // setridime vzestupne
	}

	/**
	 * @see cz.cvut.ok.kapo.paa.batoh.engines.sh.Engine#execute()
	 */
	@Override protected void run() {
		for (Item item: items){
			list.add(item);
			if (getWeight(list)>conf.getSize()){
				list.remove(list.size()-1);
				break;
			}
		}
		for (Item itm: list){
			sol.addItem(itm);
		}
	}

}
