package cz.cvut.ok.kapo.paa.batoh.engines.sh;

import cz.cvut.ok.kapo.paa.batoh.Item;

/**
 * Trida pridava pomer cena/vaha a take radi podle tohoto pomeru.
 * @author karel
 *
 */
public class SimpleHeuristicItem extends Item{
	protected double fract;
	
	/**
	 * vytvori prazdny objekt
	 */
	public SimpleHeuristicItem() {
		super();
		this.fract=0.0;
	}
	
	/**
	 * Konstruktor, vytvori novy predmet se zadanou vahou a cenou.
	 * @param cost cena predmetu
	 * @param weight vaha predmetu
	 */
	public SimpleHeuristicItem(int cost, int weight) {
		super(cost, weight);
		this.fract= (double)cost/(double)weight;
	}
	
	/**
	 * Konstruktor, vytvori novy predmet podle predlohy.
	 * @param cost cena predmetu
	 * @param weight vaha predmetu
	 */
	public SimpleHeuristicItem(Item item) {
		super(item.getCost(), item.getWeight());
		this.fract= (double)getCost()/(double)getWeight();
	}
	
	/**
	 * @param cost The cost to set.
	 */
	@Override public void setCost(int cost) {
		super.setCost(cost);
		fract= (double)getCost()/(double)getWeight();
	}
	
	/**
	 * @param weight The weight to set.
	 */
	@Override public void setWeight(int weight) {
		super.setWeight(weight);
		fract= (double)getCost()/(double)getWeight();
	}

	/**
	 * @return a fraction cost/weight
	 */
	public double getFract(){
		return fract;
	}

	/**
	 * Porovna instance (jejich pomer). Pozor: Vysledek je naopak, nez
	 * se ma chovat standardni funkce!! Je to kvuli opacnemu setrideni
	 * pomoci Arrays.sort(), tj. sestupne.
	 */
	@Override public int compareTo(Object o){
		if (getCost() == ((Item)o).getCost() && getWeight() == ((Item)o).getWeight())
			return 0;
		if ( (getFract()-((SimpleHeuristicItem)o).getFract()) > 0 )
			return -1;
		
		return 1;
	}
	
	/**
	 * @override
	 */
	@Override public String toString(){
		return " [weight="+getWeight()+" cost="+getCost() + " ("+getFract()+")]";
	}
}
